namespace :miners do
  task check_active_list: :environment do
    url = 'http://149.28.218.119:4243/active_list'
    response = HTTParty.get(url)

    response_json = JSON.parse(response.body)
    time = DateTime.new
    miners = Miner.all

    if response_json == []
      miners.each do |miner|
        miner.update(status: 'miss')
      end
    end

    miners.each do |miner|
      is_work = false
      hr_stats = 0
      check_activity_time = (DateTime.now - 5.minutes)

      response_json.each do |item|
        if item['work_id'] == miner.name
          is_work = true
          hr_stats = item["hr_stats"]
          break
        end
      end

      if is_work
        miner.update(status: 'work', hash_rate: hr_stats)
      else
        if miner.last_activity < check_activity_time
          miner.update(status: 'miss', last_activity: time, hash_rate: hr_stats)
        end
      end
    end
  end
end